blob: 74b6e43e0543cc2159efb5a5e4d640a67c2467b7 [file] [log] [blame]
Scott Baker2c1c4822019-10-16 11:02:41 -07001#
2# Copyright 2016 the original author or authors.
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
15#
16
17# set default shell
18SHELL = bash -e -o pipefail
19
20# Variables
21VERSION ?= $(shell cat ./VERSION)
22
Kent Hagermanfac11d42020-01-28 12:18:55 -050023# tool containers
24VOLTHA_TOOLS_VERSION ?= 1.0.3
25
Kent Hagerman08d15ab2020-02-14 14:54:52 -050026GO = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang go
Kent Hagermanfac11d42020-01-28 12:18:55 -050027GO_JUNIT_REPORT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-go-junit-report go-junit-report
28GOCOVER_COBERTURA = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-gocover-cobertura gocover-cobertura
Kent Hagerman08d15ab2020-02-14 14:54:52 -050029GOFMT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang gofmt
30GOLANGCI_LINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golangci-lint golangci-lint
Scott Baker2c1c4822019-10-16 11:02:41 -070031
32.PHONY: local-protos
33
34# This should to be the first and default target in this Makefile
35help:
36 @echo "Usage: make [<target>]"
37 @echo "where available targets are:"
38 @echo
39 @echo "build : Build the library"
40 @echo "clean : Remove files created by the build"
41 @echo "distclean : Remove build and testing artifacts and reports"
42 @echo "lint-style : Verify code is properly gofmt-ed"
43 @echo "lint-sanity : Verify that 'go vet' doesn't report any issues"
44 @echo "lint-mod : Verify the integrity of the 'mod' files"
45 @echo "lint : Shorthand for lint-style & lint-sanity"
46 @echo "mod-update : Update go.mod and the vendor directory"
47 @echo "test : Generate reports for all go tests"
48 @echo
49
50## Local Development Helpers
51local-protos:
52 @mkdir -p python/local_imports
53ifdef LOCAL_PROTOS
Scott Bakerf1b096c2019-11-01 12:36:30 -070054 rm -rf vendor/github.com/opencord/voltha-protos
serkant.uluderyab38671c2019-11-01 09:35:38 -070055 mkdir -p vendor/github.com/opencord/voltha-protos/v3/go
56 cp -r ${LOCAL_PROTOS}/go/* vendor/github.com/opencord/voltha-protos/v3/go
Scott Baker2c1c4822019-10-16 11:02:41 -070057 rm -rf python/local_imports/voltha-protos
58 mkdir -p python/local_imports/voltha-protos/dist
Scott Bakerf1b096c2019-11-01 12:36:30 -070059 cp ${LOCAL_PROTOS}/dist/*.tar.gz python/local_imports/voltha-protos/dist/
Scott Baker2c1c4822019-10-16 11:02:41 -070060endif
61
62## build the library
Scott Bakerf1b096c2019-11-01 12:36:30 -070063build: local-protos
Kent Hagermanfac11d42020-01-28 12:18:55 -050064 ${GO} build -mod=vendor ./...
Scott Baker2c1c4822019-10-16 11:02:41 -070065
66## lint and unit tests
67
68lint-style:
Scott Baker2c1c4822019-10-16 11:02:41 -070069 @echo "Running style check..."
Kent Hagermanfac11d42020-01-28 12:18:55 -050070 @gofmt_out="$$(${GOFMT} -l $$(find . -name '*.go' -not -path './vendor/*'))" ;\
Scott Baker2c1c4822019-10-16 11:02:41 -070071 if [ ! -z "$$gofmt_out" ]; then \
72 echo "$$gofmt_out" ;\
73 echo "Style check failed on one or more files ^, run 'go fmt' to fix." ;\
74 exit 1 ;\
75 fi
76 @echo "Style check OK"
77
78lint-sanity:
79 @echo "Running sanity check..."
Kent Hagermanfac11d42020-01-28 12:18:55 -050080 @${GO} vet -mod=vendor ./...
Scott Baker2c1c4822019-10-16 11:02:41 -070081 @echo "Sanity check OK"
82
83lint-mod:
84 @echo "Running dependency check..."
Kent Hagermanfac11d42020-01-28 12:18:55 -050085 @${GO} mod verify
Scott Bakera36b4982019-11-26 08:09:23 -080086 @echo "Dependency check OK. Running vendor check..."
87 @git status > /dev/null
88 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && echo "`git status`" && exit 1)
89 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && echo "`git status`" && exit 1)
Kent Hagermanfac11d42020-01-28 12:18:55 -050090 ${GO} mod tidy
91 ${GO} mod vendor
Scott Bakera36b4982019-11-26 08:09:23 -080092 @git status > /dev/null
93 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1)
94 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1)
95 @echo "Vendor check OK."
Scott Baker2c1c4822019-10-16 11:02:41 -070096
97lint: lint-style lint-sanity lint-mod
98
Kent Hagermanfac11d42020-01-28 12:18:55 -050099sca:
Scott Baker2c1c4822019-10-16 11:02:41 -0700100 rm -rf ./sca-report
101 @mkdir -p ./sca-report
Kent Hagermanfac11d42020-01-28 12:18:55 -0500102 ${GOLANGCI_LINT} run --out-format junit-xml ./... | tee ./sca-report/sca-report.xml
Scott Baker2c1c4822019-10-16 11:02:41 -0700103
Kent Hagermanfac11d42020-01-28 12:18:55 -0500104test:
Scott Baker2c1c4822019-10-16 11:02:41 -0700105 @mkdir -p ./tests/results
Kent Hagermanfac11d42020-01-28 12:18:55 -0500106 @${GO} test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\
Scott Baker2c1c4822019-10-16 11:02:41 -0700107 RETURN=$$? ;\
Kent Hagermanfac11d42020-01-28 12:18:55 -0500108 ${GO_JUNIT_REPORT} < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\
109 ${GOCOVER_COBERTURA} < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\
Scott Baker2c1c4822019-10-16 11:02:41 -0700110 exit $$RETURN
111
Kent Hagermanfac11d42020-01-28 12:18:55 -0500112clean: distclean
Scott Baker2c1c4822019-10-16 11:02:41 -0700113
Kent Hagermanfac11d42020-01-28 12:18:55 -0500114distclean:
115 rm -rf ./sca-report ./tests
Scott Baker2c1c4822019-10-16 11:02:41 -0700116
Kent Hagermanfac11d42020-01-28 12:18:55 -0500117mod-update:
118 ${GO} mod tidy
119 ${GO} mod vendor